/*
Copyright (c) 2002 Regents of The University of Michigan.
All Rights Reserved.

Permission to use, copy, modify, and distribute this software and
its documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appears in all copies and
that both that copyright notice and this permission notice appear
in supporting documentation, and that the name of The University
of Michigan not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission. This software is supplied as is without expressed or
implied warranties of any kind.

Research Systems Unix Group
The University of Michigan
c/o Wesley Craig
4251 Plymouth Road B1F2, #2600
Ann Arbor, MI 48105-2785
radmind@umich.edu
http://rsug.itd.umich.edu/software/radmind/
*/

#import <Cocoa/Cocoa.h>
#import <Security/Authorization.h>

@class RXTranscript;

@protocol RXTranscriptAuthInterface

- ( oneway void )executeAction: ( int )action
                arguments: ( NSArray * )args
                controller: ( RXTranscript * )rxt;

- ( void )disconnect;

@end

@interface RXAuthRW : NSObject <RXTranscriptAuthInterface>
{
@private
    int         _rteThreadID;
    id          _rteController;
}

+ ( void )connectWithPorts: ( NSArray * )ports;
- ( void )setThreadID: ( int )ID;
- ( int )threadID;

- ( int )executeAuthorizedTask: ( int )action withArguments: ( NSArray * )args
            authRef: ( AuthorizationRef )authRef forTranscript: ( RXTranscript * )rxt;
- ( int )prepareAuthorizedTask: ( int )action withArguments: ( NSArray * )args
            forTranscript: ( RXTranscript * )rxt;

@end