/*
Copyright (c) 2002 Regents of The University of Michigan.
All Rights Reserved.

Permission to use, copy, modify, and distribute this software and
its documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appears in all copies and
that both that copyright notice and this permission notice appear
in supporting documentation, and that the name of The University
of Michigan not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission. This software is supplied as is without expressed or
implied warranties of any kind.

Research Systems Unix Group
The University of Michigan
c/o Wesley Craig
4251 Plymouth Road B1F2, #2600
Ann Arbor, MI 48105-2785

http://rsug.itd.umich.edu/software/radmind
radmind@umich.edu
*/

#import <Cocoa/Cocoa.h>
#import "RXTranscript.h"

/* actions used across nibs */

@interface FirstResponder : NSObject

- ( IBAction )showInfo: ( id )sender;	/* for Show Info menu item */
- ( IBAction )toggleDrawer: ( id )sender; /* toggle transcript line drawer */
- ( IBAction )save: ( id )sender; /* override saving behaviours */
- ( IBAction )saveAs: ( id )sender;
- ( IBAction )copySelectedLines: ( id )sender;	/* copy, cut & paste implementations */
- ( IBAction )cutSelectedLines: ( id )sender;
- ( IBAction )pasteLinesFromClipboard: ( id )sender;

/* display advanced search panel */
- ( IBAction )displayAdvancedSearchPanel: ( id )sender;

/* comment methods */
- ( IBAction )toggleCommentOnSelectedLine: ( id )sender;

/* add item sheet */
- ( IBAction )getAddItemSheet: ( id )sender;

/* go to line */
- ( IBAction )showGotoLinePanel: ( id )sender;

/* run twhich on the selected line */
- ( void )showSourceTranscripts: ( id )sender;
